/*
 * Copyright (c) 1994 Vectaport Inc., Cartoactive Systems
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

/* Class wrapper for dlg library object */

#ifndef dlglib_h
#define dlglib_h

#include <Map/maplib.h>

class DlgCoverage;
class DlgDatabase;

class DlgLibrary : public MapLibrary {
public:
    DlgLibrary (DlgDatabase*, const char *);
    virtual ~DlgLibrary ();

    DlgDatabase* database() const { return (DlgDatabase*)_database; }
    virtual void database(DlgDatabase* db) { _database = (MapDatabase*)db; }

    DlgCoverage* coverage(unsigned covnum) const;
    DlgCoverage* coverage(const char*) const;

protected:
    virtual char** coverage_names (int& ncovs) const;
    virtual MapCoverage* make_coverage(const char* name);
};

#endif /* defined(dlglib_h) */
