/*
 * Copyright 1994, 1995 Vectaport Inc., Cartoactive Systems
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

/* map database object */

#ifndef mapdb_h
#define mapdb_h

#include <Map/mapfiles.h>

class MapLibrary;
class ostream;

class MapDatabase : public MapFiles {
protected:
    MapDatabase(const char* name, const char *path);

public:
    virtual ~MapDatabase();

    int nlibs() const;
    MapLibrary* library(unsigned libnum) const;
    MapLibrary* library(const char*) const;

    virtual const char* description() const;
    friend ostream& operator << (ostream& s, const MapDatabase&);

protected:
    void init_libraries();
    boolean initialized() const { return _nlibs>=0; }

    virtual char** library_names(int &nlibs) const = 0;
    virtual MapLibrary* make_library(const char* name) = 0;

protected:

    int _nlibs;
    MapLibrary** _libraries;

};

#endif /* defined(mapdb_h) */
